import java.applet.Applet; 
import java.awt.*; 
import java.awt.event.*; 
import java.awt.image.*; 
import java.net.Socket;
import java.net.URL;
import java.net.URLConnection;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class empegApplet extends Applet 
	implements Runnable,MouseListener { 
int arrayLength, pixels[]; 
Thread runThread=null; 
MemoryImageSource source; 
Image image,bgImage; 
int width, height, dwidth, dheight, iwidth, iheight ; 
Image offScreenImage;
Graphics offScreenGC;
Socket s = null;
DataInputStream in = null;
DataOutputStream out = null;
byte[] img = new byte[1024];
int[] colors = new int[4];
int p;
URL MyUrl, tttURL;
int port;
String hostname,sl;
MediaTracker imageTracker;
Polygon Ptop,Pleft,Pright,Pbottom;
double xfactor,yfactor;

public void init() { 
	colors[0]=(255 << 24) |
		Integer.decode(getParameter("color0")).intValue();
	colors[1]=(255 << 24) |
		Integer.decode(getParameter("color1")).intValue();
	colors[2]=(255 << 24) |
		Integer.decode(getParameter("color2")).intValue();
	colors[3]=(255 << 24) |
		Integer.decode(getParameter("color3")).intValue();
	sl=getParameter("sleeptime");
	MyUrl=this.getCodeBase();
	hostname=MyUrl.getHost();
	port=MyUrl.getPort();
	if ( port == -1 )
		port = 80;
	imageTracker = new MediaTracker(this);
	bgImage = getImage(getCodeBase(),"fascia.jpg");
	imageTracker.addImage(bgImage,0);
	try {
		imageTracker.waitForAll();
	} catch ( InterruptedException e ) {
		System.out.println("load Image: "+e);
	}
	iwidth = bgImage.getWidth(this); 
	iheight = bgImage.getHeight(this); 
	dwidth = 128; 
	dheight = 32; 
	width = getSize().width; 
	height = getSize().height; 
	arrayLength = dwidth * dheight; 
	pixels = new int [arrayLength]; 
	source = new MemoryImageSource(dwidth, dheight, pixels, 0, dwidth); 
	source.setAnimated(true); 
	image = createImage(source);
	xfactor=width/iwidth;
	yfactor=height/iheight;
	Ptop=new Polygon();
	Ptop.addPoint((int)(41*xfactor),(int)(25*yfactor));
	Ptop.addPoint((int)(46*xfactor),(int)(25*yfactor));
	Ptop.addPoint((int)(49*xfactor),(int)(28*yfactor));
	Ptop.addPoint((int)(49*xfactor),(int)(32*yfactor));
	Ptop.addPoint((int)(46*xfactor),(int)(35*yfactor));
	Ptop.addPoint((int)(41*xfactor),(int)(35*yfactor));
	Ptop.addPoint((int)(38*xfactor),(int)(32*yfactor));
	Ptop.addPoint((int)(38*xfactor),(int)(28*yfactor));
	Pleft=new Polygon();
	Pleft.addPoint((int)(41*xfactor),(int)(40*yfactor));
	Pleft.addPoint((int)(41*xfactor),(int)(51*yfactor));
	Pleft.addPoint((int)(37*xfactor),(int)(54*yfactor));
	Pleft.addPoint((int)(21*xfactor),(int)(47*yfactor));
	Pleft.addPoint((int)(32*xfactor),(int)(40*yfactor));
	Pright=new Polygon();
	Pright.addPoint((int)(46*xfactor),(int)(40*yfactor));
	Pright.addPoint((int)(55*xfactor),(int)(40*yfactor));
	Pright.addPoint((int)(66*xfactor),(int)(47*yfactor));
	Pright.addPoint((int)(50*xfactor),(int)(54*yfactor));
	Pright.addPoint((int)(46*xfactor),(int)(51*yfactor));
	Pbottom=new Polygon();
	Pbottom.addPoint((int)(43*xfactor),(int)(55*yfactor));
	Pbottom.addPoint((int)(49*xfactor),(int)(58*yfactor));
	Pbottom.addPoint((int)(43*xfactor),(int)(76*yfactor));
	Pbottom.addPoint((int)(38*xfactor),(int)(58*yfactor));
	addMouseListener(this);
}

public void main() {
	Frame appletFrame = new Frame("empegApplet");
	Applet empApplet = new empegApplet();
	empApplet.init();
	empApplet.start();
	appletFrame.setLayout(new FlowLayout());
	appletFrame.add(empApplet);
	appletFrame.setSize(300,100);
	appletFrame.show();
}
 
public void start() { 
	if( runThread == null){ 
		try {
			s=new Socket(hostname,port);
			in = new DataInputStream(s.getInputStream());
			out = new DataOutputStream(s.getOutputStream());
		} catch ( IOException e ) {
			System.out.println(e);
			return;
		}
		try {
			out.writeBytes("STREAM /empeg_stream\n");
			out.writeBytes("request-delay: "+sl+"\n\n");
			out.flush();
		} catch ( IOException e ) {
			System.out.println("write: "+e);
			return;
		}
		runThread = new Thread(this); 
		runThread.start(); 
	} 
} 

public void stop() {
	try {
		out.writeBytes("\n");
		in.close();
		out.close();
	} catch ( IOException e ) {
		System.out.println("write: "+e);
		return;
	}
	in=null;
	out=null;
	runThread.stop();
	runThread=null; 
} 

public void update(Graphics g) { 

	if (offScreenImage == null) { 
		offScreenImage = createImage( width,height ); 
		offScreenGC = offScreenImage.getGraphics(); 
	} 
	offScreenGC.drawImage(bgImage,0,0,width,height,this); 
	paint(offScreenGC);
	g.drawImage(offScreenImage,0,0, this);
}

public void run() { 
    while (runThread !=null) { 
	try { in.readFully(img); } catch ( Exception e ) {
		System.out.println("read: "+e);
		return;
	}

      //try { 
       // Thread.sleep(1000/24); 
      //} catch( InterruptedException e ) { /* die */ } 

	int index = 0; 
	for (int i=0;i<32;i++)
        {
		for (int j=0;j<32;j++)
		{
			for (int k=0;k<4;k++)
			{
				if ( k>0 ) {
					p=(img[(i*32)+j] >>> (k*2)) & 3;
				} else	{ p=img[(i*32)+j] & 3; }
				pixels[index++]=colors[p];
				//System.out.println(
			//"pixel :"+k+":"+img[(i*32)+j]+":"+colors[p]+":\n");
			}
		}
	}
	
      // Push out the new data and initiate a repaint()
      source.newPixels(0, 0, width, height); 
    } 
  } 
  
public void paint( Graphics g ) { 
	Image tImage = createImage( 128,32); 
	tImage.getGraphics().drawImage(image,0,0,this);
	g.drawImage(tImage,
		(int)(width*0.31),
		(int)(height*0.31),
		dwidth * (int)xfactor,
		dheight * (int)yfactor,
		this); 
}


public void mousePressed(MouseEvent event) {
	Point MyPoint=event.getPoint();
	try {
		if ( Ptop.contains(MyPoint) ) {
			out.writeBytes("0 0\n");
		}
		if ( Pright.contains(MyPoint) ) {
			out.writeBytes("0 2\n");
		}
		if ( Pleft.contains(MyPoint) ) {
			out.writeBytes("0 4\n");
		}
		if ( Pbottom.contains(MyPoint) ) {
			out.writeBytes("0 6\n");
		}
	} catch ( IOException e ) {
		System.out.println("write: "+e);
		return;
		}
    }

    public void mouseReleased(MouseEvent event) {
	Point MyPoint=event.getPoint();
	try {
		if ( Ptop.contains(MyPoint) ) {
			out.writeBytes("0 1\n");
		}
		if ( Pright.contains(MyPoint) ) {
			out.writeBytes("0 3\n");
		}
		if ( Pleft.contains(MyPoint) ) {
			out.writeBytes("0 5\n");
		}
		if ( Pbottom.contains(MyPoint) ) {
			out.writeBytes("0 7\n");
		}
	} catch ( IOException e ) {
		System.out.println("write: "+e);
		return;
		}
    }

    public void mouseEntered(MouseEvent event) {
    }

    public void mouseExited(MouseEvent event) {
    }

    public void mouseClicked(MouseEvent event) {
	showStatus(event.getPoint().toString());
    }
     
} 


